    PROGRAM g01hafe

!      G01HAF Example Program Text

!      Mark 23 Release. NAG Copyright 2011.

!      .. Use Statements ..
       USE nag_library, ONLY : g01haf, nag_wp
!      .. Implicit None Statement ..
       IMPLICIT NONE
!      .. Parameters ..
       INTEGER, PARAMETER              :: nin = 5, nout = 6
!      .. Local Scalars ..
       REAL (KIND=nag_wp)              :: prob, rho, x, y
       INTEGER                         :: ifail
!      .. Executable Statements ..
       WRITE (nout,*) 'G01HAF Example Program Results'
       WRITE (nout,*)

!      Skip heading in data file
       READ (nin,*)

!      Display titles
       WRITE (nout,*) '     X       Y      RHO    PROB'
       WRITE (nout,*)

D_LP:  DO
          READ (nin,*,IOSTAT=ifail) x, y, rho
          IF (ifail/=0) THEN
             EXIT D_LP
          END IF

!         Calculate probability
          ifail = 0
          prob = g01haf(x,y,rho,ifail)

!         Display results
          WRITE (nout,99999) x, y, rho, prob
       END DO D_LP

99999  FORMAT (1X,3F8.3,F8.4)
    END PROGRAM g01hafe
